require 'soar/authorization/access_manager/provider/stub'
require 'soar/authorization/access_manager/provider/policy'
require 'soar/authorization/access_manager/provider/service_registry'

module Soar
  module Authorization
    module AccessManager
      class Model 

        def initialize(provider)
          @provider = provider
        end

        ##
        # @param service_identifier [String] 
        # @param resource_identifier [String] 
        # @param request [Hash]
        ##
        def authorized?(service_identifier: nil, resource_identifier: nil, request: nil)
          @provider.authorized?(service_identifier, resource_identifier, request)
        end

      end

    end
  end
end
